using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Threading;

using CCM;

namespace CCM.Seat
{

	public class Button : CCM.Comp
	{
		// Coops
		public VFS OUT = new VFS(3);

		byte buttons = 1;
		bool flank = false;
		bool locked = false;
		bool on = false;
		bool stopOnFbFail = false;
		bool[] pressed;

		public Button(byte buttons,bool flank,bool stopOnFbFail) 
		{
			if (buttons == 0) throw new Exception();
			if (flank && (buttons != 1)) throw new Exception();
			this.buttons = buttons;
			this.flank = flank;
			this.stopOnFbFail = stopOnFbFail;
			if (flank) OUT = new VFS(1); 
			else OUT = new VFS((byte) (buttons+1));
			pressed = new bool[buttons];
		}

		string lockvar = "";
		byte flanks = 0;
		byte oldFlanks = 0;

		[Event] public void setPressed( [Range(1,"buttons")] byte button,bool val) 
		{
			lock (lockvar) 
			{
				if ((button<1) || (button > buttons)) throw new Exception();
				pressed[button-1] = val;

				// Sonderbehandlung Flankensteuerung
				if (val && (oldFlanks == flanks))
				    if( ++flanks == 10 )
					flanks = 0;
			}
			
			EventOccured();
		}
		
		bool moreThenOnePressed = false;
		bool onePressed = false;
		bool nothingPressed = false;
		byte onePressedIndex;  // nur gltig, wenn onePressed == true;
	
		void evalPressed() 
		{
			nothingPressed = true;
			moreThenOnePressed = false;
			for (int i=0; i<buttons; i++)
			{
				if (!pressed[i]) continue;
				onePressedIndex = (byte) i;
				if (!nothingPressed) moreThenOnePressed = true;
				nothingPressed = false;
			};
			onePressed = !nothingPressed && !moreThenOnePressed;
		}

		protected override void Run() 
		{
			evalPressed();

			if (moreThenOnePressed) locked = true;

			if (on && stopOnFbFail)
				if (!OUT.checkStateFeedback(1500)) locked = true;

			if (nothingPressed) locked = false;

			if (on && locked )
			{ 
				Common.log(this,"Stop due extra condition");
				locked = true;
			}

			if (on && (locked || nothingPressed))
			{ 
				OUT.Cont = -1.0F; OUT.State = 0;
				on = false; 
				OUT.releaseCooperation();
				Common.log(this,"off");
			}

			if (!on && !flank && onePressed && !locked) 
			{
				on = true;
				OUT.acquireCooperation();
				OUT.Cont = -1.0F; 
				OUT.State = (byte) (onePressedIndex + 1);
				Common.log(this,"on");
			}

			if (!on && flank && (oldFlanks != flanks) && !locked) 
			{
				Common.log(this,"Update flank signal");
				OUT.Cont = -1.0F; 
				OUT.State = flanks;
				oldFlanks = flanks;
			}
			active = on;
		}

	}
}
