using System;
using System.ComponentModel;
using System.Collections;
using System.Diagnostics;

using CCM;

namespace CCM.Seat
{
        /// Abstraction of speed: only two states "stop" (go==false) and
	/// "driving" (go==true)
	public class SpeedAbstr : Comp
	{
		// Stubs
		[Property("Cont"), Eq( 0.0, 0.0 ), Eq( 10.0, "(0.0,oo)" )]
		public VFS OUT = new VFS(0);

		[Abstracts("speed"), Eq( false, 0.0 ), Eq( true, "(0.0,oo)") ]
		bool go = false;
	
		protected override void Run() 
		{
			if( go )
			    OUT.Cont = 10.0;
			else
			    OUT.Cont = 0.0;
		}

		[Event] public void setSpeed( [Range(0.0,60.0,20.0)] float speed) 
		{
			this.go = (speed != 0.0);
			//this.go = (speed > 20.0);
			EventOccured();
		}
	}
}
